package org.jeecg.modules.stm.wb.config.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.wb.config.entity.WbScene;
import org.jeecg.modules.stm.wb.config.service.IWbSceneService;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: wb_scene
 * @Author: jeecg-boot
 * @Date:   2025-06-16
 * @Version: V1.0
 */

@RestController
@RequestMapping("/wb/config/wbScene")
@Slf4j
public class WbSceneController extends JeecgController<WbScene, IWbSceneService> {
	@Autowired
	private IWbSceneService wbSceneService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbScene
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "wb_scene-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<WbScene>> queryPageList(WbScene wbScene,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbScene> queryWrapper = QueryGenerator.initQueryWrapper(wbScene, req.getParameterMap());
		Page<WbScene> page = new Page<WbScene>(pageNo, pageSize);
		IPage<WbScene> pageList = wbSceneService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbScene
	 * @return
	 */
	@AutoLog(value = "wb_scene-添加")

	@RequiresPermissions("wb/config:wb_scene:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbScene wbScene) {
		wbSceneService.save(wbScene);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbScene
	 * @return
	 */
	@AutoLog(value = "wb_scene-编辑")

	@RequiresPermissions("wb/config:wb_scene:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbScene wbScene) {
		wbSceneService.updateById(wbScene);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "wb_scene-通过id删除")

	@RequiresPermissions("wb/config:wb_scene:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbSceneService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "wb_scene-批量删除")

	@RequiresPermissions("wb/config:wb_scene:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbSceneService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "wb_scene-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<WbScene> queryById(@RequestParam(name="id",required=true) String id) {
		WbScene wbScene = wbSceneService.getById(id);
		if(wbScene==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbScene);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbScene
    */
    @RequiresPermissions("wb/config:wb_scene:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbScene wbScene) {
        return super.exportXls(request, wbScene, WbScene.class, "wb_scene");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb/config:wb_scene:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbScene.class);
    }

}
